package com.cm.sa.admin.module.business.order.service;

package ..deTemp.1742362326147;

import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.date.LocalDateTimeUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.json.JSONUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.cm.sa.admin.module.business.commission.domain.entity.BalanceChangeEntity;
import com.cm.sa.admin.module.business.commission.domain.entity.CommissionRecordEntity;
import com.cm.sa.admin.module.business.commission.domain.entity.CommissionRecordTraceEntity;
import com.cm.sa.admin.module.business.commission.domain.entity.CommissionTotalEntity;
import com.cm.sa.admin.module.business.order.dao.CardOrderDetailDao;
import com.cm.sa.admin.module.business.order.dao.HttpLogDao;
import com.cm.sa.admin.module.business.order.dao.OrderDao;
import com.cm.sa.admin.module.business.order.dao.OrderSubStatusDao;
import com.cm.sa.admin.module.business.order.domain.entity.CardOrderDetailEntity;
import com.cm.sa.admin.module.business.order.domain.entity.HttpLogEntity;
import com.cm.sa.admin.module.business.order.domain.entity.OrderEntity;
import com.cm.sa.admin.module.business.order.domain.entity.OrderSubStatusEntity;
import com.cm.sa.admin.module.business.order.domain.form.OrderAddCardForm;
import com.cm.sa.admin.module.business.order.domain.form.OrderLandpageQueryForm;
import com.cm.sa.admin.module.business.order.domain.form.OrderQueryAgentForm;
import com.cm.sa.admin.module.business.order.domain.form.OrderQueryForm;
import com.cm.sa.admin.module.business.order.domain.form.OrderUpdateForm;
import com.cm.sa.admin.module.business.order.domain.vo.CardOrderDetailVO;
import com.cm.sa.admin.module.business.order.domain.vo.OrderChannelVO;
import com.cm.sa.admin.module.business.order.domain.vo.OrderPageVO;
import com.cm.sa.admin.module.business.order.domain.vo.OrderSubStatusVO;
import com.cm.sa.admin.module.business.order.domain.vo.OrderVO;
import com.cm.sa.admin.module.business.order.manager.OrderManager;
import com.cm.sa.admin.module.business.order.service.ChangeOrderStatusService;
import com.cm.sa.admin.module.business.order.service.OrderStatusServiceFactory;
import com.cm.sa.admin.module.business.product.dao.CardProductDao;
import com.cm.sa.admin.module.business.product.dao.CardProductInfoDao;
import com.cm.sa.admin.module.business.product.domain.entity.CardProductEntity;
import com.cm.sa.admin.module.business.product.domain.entity.CardProductInfoEntity;
import com.cm.sa.admin.module.business.product.domain.vo.CardProductInfoVO;
import com.cm.sa.admin.module.business.product.domain.vo.CardProductVO;
import com.cm.sa.admin.module.business.product.service.CardProductService;
import com.cm.sa.admin.module.business.shop.dao.AgentWithdrawAccountDao;
import com.cm.sa.admin.module.system.employee.dao.EmployeeDao;
import com.cm.sa.admin.module.system.employee.domain.entity.EmployeeEntity;
import com.cm.sa.admin.module.system.employee.domain.vo.EmployeeVO;
import com.cm.sa.base.common.code.SystemErrorCode;
import com.cm.sa.base.common.code.UserErrorCode;
import com.cm.sa.base.common.domain.PageParam;
import com.cm.sa.base.common.domain.PageResult;
import com.cm.sa.base.common.domain.ResponseDTO;
import com.cm.sa.base.common.exception.BusinessException;
import com.cm.sa.base.common.util.SmartBeanUtil;
import com.cm.sa.base.common.util.SmartBigDecimalUtil;
import com.cm.sa.base.common.util.SmartPageUtil;
import com.cm.sa.base.common.util.SmartRequestUtil;
import com.cm.sa.base.module.support.config.ConfigKeyEnum;
import com.cm.sa.base.module.support.config.ConfigService;
import com.cm.sa.base.module.support.dict.service.DictCacheService;
import com.cm.sa.base.module.support.serialnumber.constant.SerialNumberIdEnum;
import com.cm.sa.base.module.support.serialnumber.service.impl.SerialNumberRedisService;
import java.lang.reflect.Method;
import java.math.BigDecimal;
import java.time.LocalDateTime;
import java.util.Collections;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import javax.annotation.Resource;
import org.apache.commons.collections4.CollectionUtils;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

@Service
public class OrderService {
  private static final Logger log = LoggerFactory.getLogger(com.cm.sa.admin.module.business.order.service.OrderService.class);
  
  @Resource
  private OrderDao orderDao;
  
  @Resource
  private HttpLogDao httpLogDao;
  
  @Resource
  private OrderManager orderManager;
  
  @Resource
  private CardOrderDetailDao cardOrderDetailDao;
  
  @Resource
  private CardProductService cardProductService;
  
  @Resource
  private CardProductDao cardProductDao;
  
  @Resource
  private DictCacheService dictCacheService;
  
  @Resource
  private ConfigService configService;
  
  @Resource
  private EmployeeDao employeeDao;
  
  @Resource
  private CardProductInfoDao cardProductInfoDao;
  
  @Resource
  private OrderSubStatusDao orderSubStatusDao;
  
  @Resource
  private AgentWithdrawAccountDao agentWithdrawAccountDao;
  
  @Resource
  private SerialNumberRedisService serialNumberRedisService;
  
  public PageResult<OrderPageVO> queryPage(OrderQueryForm queryForm) {
    Long requestUserId = SmartRequestUtil.getRequestUserId();
    Page<?> page = SmartPageUtil.convert2PageQuery((PageParam)queryForm);
    List<OrderPageVO> list = this.orderDao.queryPage(page, queryForm);
    fillOrderAmount(list, OrderPageVO.class, requestUserId);
    return SmartPageUtil.convert2PageResult(page, list);
  }
  
  private void fillOrderAmount(List<?> list, Class<?> clazz, Long requestUserId) {
    if (CollectionUtils.isNotEmpty(list)) {
      Class<?> listClass = list.get(0).getClass();
      if (!listClass.equals(clazz)) {
        log.error("请保持list中类型与方法传递class一致，list:{}，class:{}", listClass.getName(), clazz.getName());
        throw new BusinessException(SystemErrorCode.SYSTEM_ERROR);
      } 
    } 
    try {
      Method getCommissionSnapshot = clazz.getMethod("getCommissionSnapshot", new Class[0]);
      Method setCommissionSnapshot = clazz.getMethod("setCommissionSnapshot", new Class[] { String.class });
      Method setOrderAmount = clazz.getMethod("setOrderAmount", new Class[] { BigDecimal.class });
      list.forEach(e -> {
            try {
              String commissionSnapshot = (String)getCommissionSnapshot.invoke(e, new Object[0]);
              if (StringUtils.isNotBlank(commissionSnapshot)) {
                Map<?, ?> map = (Map<?, ?>)JSONObject.parseObject(commissionSnapshot, Map.class);
                JSONObject jsonObject = (JSONObject)map.get(requestUserId + "");
                if (jsonObject != null) {
                  setOrderAmount.invoke(e, new Object[] { jsonObject.getBigDecimal("amount") });
                  setCommissionSnapshot.invoke(e, new Object[] { "" });
                } 
              } 
            } catch (Exception ex) {
              log.error("执行方法出错，{}", clazz.getName(), ex);
              throw new BusinessException(SystemErrorCode.SYSTEM_ERROR.getMsg());
            } 
          });
    } catch (NoSuchMethodException e) {
      log.error("未找到方法 getCommissionSnapshot 或 setCommissionSnapshot 或 setOrderAmount ，{}", clazz.getName());
      throw new BusinessException(SystemErrorCode.SYSTEM_ERROR.getMsg());
    } 
  }
  
  public ResponseDTO<String> add(OrderAddCardForm addForm) {
    int orderCounts = this.orderDao.selectRepiectOrder(addForm.getCardProductId(), addForm.getCustomerIdcard(), addForm
        .getProvince() + addForm.getCity() + addForm.getDistrict() + addForm.getDetailAddress(), addForm.getSelectPhoneNo()).intValue();
    log.info("下单数量：：：：" + orderCounts);
    if (orderCounts > 0)
      return ResponseDTO.userErrorParam("24h内请勿重复下单！"); 
    if ("704001".equals(addForm.getProductType())) {
      String orderNo = this.serialNumberRedisService.generate(SerialNumberIdEnum.ORDER);
      addForm.setOrderNo(orderNo);
      this.orderManager.addCard(addForm);
    } 
    try {
      Thread.sleep(20000L);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    OrderVO orderVO = (OrderVO)SmartBeanUtil.copy(addForm, OrderVO.class);
    return this.orderManager.sendOrder(orderVO);
  }
  
  public List<OrderEntity> getOrderBySecondCommission(int day) {
    return this.orderDao.getOrderBySecondCommission(day);
  }
  
  @Transactional(rollbackFor = {Exception.class})
  public void SecondCommissionOrder(OrderEntity orderEntity) {
    orderEntity.setPaymentStatus("610201");
    orderEntity.setOrderStatus("610104");
    this.orderManager.updateCommissionRecord(orderEntity);
    orderEntity.setPaymentTime(LocalDateTime.now());
    this.orderDao.updateById(orderEntity);
  }
  
  @Transactional(rollbackFor = {Exception.class})
  public ResponseDTO<String> orderChangeOldNew(OrderChannelVO orderChannelVO) {
    OrderEntity orderEntity = getOrderByNo(orderChannelVO.getChannelOrderNo());
    CardOrderDetailEntity cardOrderDetailEntity = getOrderDetailByOrderId(orderEntity.getOrderId());
    orderEntity.setPartnerOrderNo(orderChannelVO.getOrderNo());
    String status = ObjectUtil.isNotEmpty(orderChannelVO.getOrderStatus()) ? orderChannelVO.getOrderStatus() : (ObjectUtil.isNotEmpty(orderChannelVO.getRechargeStatus()) ? orderChannelVO.getRechargeStatus() : (ObjectUtil.isNotEmpty(orderChannelVO.getActivateStatus()) ? orderChannelVO.getActivateStatus() : (ObjectUtil.isNotEmpty(orderChannelVO.getAcceptanceStatus()) ? orderChannelVO.getAcceptanceStatus() : orderChannelVO.getExpressStatus())));
    HttpLogEntity httpLogEntity = new HttpLogEntity();
    httpLogEntity.setOrderId(orderEntity.getOrderId());
    httpLogEntity.setOrderNo(orderEntity.getOrderNo());
    httpLogEntity.setSubStatus(status);
    httpLogEntity.setSubStatusDesc(orderChannelVO.getStatusDesc());
    httpLogEntity.setOrderLogType(Boolean.valueOf(true));
    httpLogEntity.setRequestParam(JSONUtil.toJsonStr(orderChannelVO));
    httpLogEntity.setResponParam(ResponseDTO.ok().toString());
    if (ObjectUtil.isNull(status)) {
      httpLogEntity.setResponParam(ResponseDTO.userErrorParam("无状态信息").toString());
      this.httpLogDao.insert(httpLogEntity);
      return ResponseDTO.userErrorParam("无状态信息");
    } 
    this.httpLogDao.insert(httpLogEntity);
    orderEntity.setStatusDesc(orderChannelVO.getStatusDesc());
    String statusType = "";
    if ("610104".compareTo(orderEntity.getOrderStatus()) > 0 && 
      !"610102".equals(orderEntity.getOrderStatus()) && 
      !"unActivity".equals(orderEntity.getRemark())) {
      ChangeOrderStatusService orderStatusService = OrderStatusServiceFactory.buildImpl(status);
      orderStatusService.changeOrderStatus(orderEntity, orderChannelVO, cardOrderDetailEntity, status);
      statusType = orderStatusService.getOrderStatusType();
      orderEntity.setUpdateTime(LocalDateTime.now());
    } 
    if (ObjectUtil.isNotEmpty(orderChannelVO.getRechargeAmount()))
      cardOrderDetailEntity.setUpdateTime(LocalDateTime.now()); 
    orderEntity.setOrderSubStatusName(this.dictCacheService.selectValueNameByValueCode(status));
    if (ObjectUtil.isNotEmpty(orderChannelVO.getSelectPhoneNo())) {
      cardOrderDetailEntity.setSelectPhoneNo(orderChannelVO.getSelectPhoneNo());
      orderEntity.setBusinessNo(orderChannelVO.getSelectPhoneNo());
    } 
    if (ObjectUtil.isNotEmpty(orderChannelVO.getExpressNo())) {
      cardOrderDetailEntity.setExpressNo(orderChannelVO.getExpressNo());
      cardOrderDetailEntity.setExpressCompany(orderChannelVO.getExpressCompany());
      orderEntity.setExpressStatus(orderChannelVO.getExpressStatus());
      orderEntity.setExpressNo(orderChannelVO.getExpressNo());
      orderEntity.setExpressCompany(orderChannelVO.getExpressCompany());
    } 
    this.orderDao.updateById(orderEntity);
    this.cardOrderDetailDao.updateById(cardOrderDetailEntity);
    if (!"".equals(statusType))
      updateOrderStatus(orderEntity, orderChannelVO, statusType, status); 
    return ResponseDTO.ok();
  }
  
  public ResponseDTO<String> orderChange(OrderChannelVO orderChannelVO) {
    OrderEntity orderEntity = getOrderByNo(orderChannelVO.getChannelOrderNo());
    CardOrderDetailEntity cardOrderDetailEntity = getOrderDetailByOrderId(orderEntity.getOrderId());
    orderEntity.setPartnerOrderNo(orderChannelVO.getOrderNo());
    String status = ObjectUtil.isNotEmpty(orderChannelVO.getOrderStatus()) ? orderChannelVO.getOrderStatus() : (ObjectUtil.isNotEmpty(orderChannelVO.getRechargeStatus()) ? orderChannelVO.getRechargeStatus() : (ObjectUtil.isNotEmpty(orderChannelVO.getActivateStatus()) ? orderChannelVO.getActivateStatus() : (ObjectUtil.isNotEmpty(orderChannelVO.getAcceptanceStatus()) ? orderChannelVO.getAcceptanceStatus() : orderChannelVO.getExpressStatus())));
    HttpLogEntity httpLogEntity = new HttpLogEntity();
    httpLogEntity.setOrderId(orderEntity.getOrderId());
    httpLogEntity.setOrderNo(orderEntity.getOrderNo());
    httpLogEntity.setSubStatus(status);
    httpLogEntity.setSubStatusDesc(orderChannelVO.getStatusDesc());
    httpLogEntity.setOrderLogType(Boolean.valueOf(true));
    httpLogEntity.setRequestParam(JSONUtil.toJsonStr(orderChannelVO));
    httpLogEntity.setResponParam(ResponseDTO.ok().toString());
    if (ObjectUtil.isNull(status)) {
      httpLogEntity.setResponParam(ResponseDTO.userErrorParam("无状态信息").toString());
      this.httpLogDao.insert(httpLogEntity);
      return ResponseDTO.userErrorParam("无状态信息");
    } 
    httpLogEntity.setResponParam(ResponseDTO.ok().toString());
    this.httpLogDao.insert(httpLogEntity);
    String statusType = "";
    if ("610103".compareTo(orderEntity.getOrderStatus()) > 0 && 
      !"610102".equals(orderEntity.getOrderStatus()) && 
      !"unActivity".equals(orderEntity.getRemark())) {
      ChangeOrderStatusService orderStatusService = OrderStatusServiceFactory.buildImpl(status);
      orderStatusService.changeOrderStatus(orderEntity, orderChannelVO, cardOrderDetailEntity, status);
      statusType = orderStatusService.getOrderStatusType();
      orderEntity.setUpdateTime(LocalDateTime.now());
    } 
    if (ObjectUtil.isNotEmpty(orderChannelVO.getRechargeAmount())) {
      cardOrderDetailEntity.setUpdateTime(LocalDateTime.now());
      cardOrderDetailEntity.setRechargeAmount(new BigDecimal(orderChannelVO.getRechargeAmount()));
    } 
    orderEntity.setOrderSubStatusName(this.dictCacheService.selectValueNameByValueCode(status));
    if (ObjectUtil.isNotEmpty(orderChannelVO.getSelectPhoneNo())) {
      cardOrderDetailEntity.setSelectPhoneNo(orderChannelVO.getSelectPhoneNo());
      orderEntity.setBusinessNo(orderChannelVO.getSelectPhoneNo());
    } 
    if (ObjectUtil.isNotEmpty(orderChannelVO.getExpressNo())) {
      cardOrderDetailEntity.setExpressNo(orderChannelVO.getExpressNo());
      cardOrderDetailEntity.setExpressCompany(orderChannelVO.getExpressCompany());
      orderEntity.setExpressStatus(orderChannelVO.getExpressStatus());
      orderEntity.setExpressNo(orderChannelVO.getExpressNo());
      orderEntity.setExpressCompany(orderChannelVO.getExpressCompany());
    } 
    log.info("开始更新订单表：" + orderEntity.getOrderNo());
    this.orderDao.updateById(orderEntity);
    log.info("开始更新订单详情表：" + orderEntity.getOrderNo());
    this.cardOrderDetailDao.updateById(cardOrderDetailEntity);
    if (!"".equals(statusType)) {
      log.info("开始更新订单状态表：" + orderEntity.getOrderNo());
      updateOrderStatus(orderEntity, orderChannelVO, statusType, status);
    } 
    return ResponseDTO.ok();
  }
  
  public void updateOrderStatus(OrderEntity orderEntity, OrderChannelVO orderChannelVO, String statusType, String status) {
    List<OrderSubStatusEntity> statusList = this.orderSubStatusDao.selectListByOrderId(orderEntity.getOrderId());
    OrderSubStatusEntity activeStatusEntity = null;
    OrderSubStatusEntity expressStatusEntity = null;
    OrderSubStatusEntity acceptStatusEntity = null;
    if (CollectionUtil.isNotEmpty(statusList) && statusList.size() > 0)
      for (OrderSubStatusEntity statusEntity : statusList) {
        switch (statusEntity.getStatusType()) {
          case "710013":
            activeStatusEntity = statusEntity;
          case "710012":
            expressStatusEntity = statusEntity;
          case "710011":
            acceptStatusEntity = statusEntity;
        } 
      }  
    OrderSubStatusEntity orderSubStatusEntity = this.orderSubStatusDao.selectByOrderIdAndStatusType(orderEntity.getOrderId(), statusType);
    if (ObjectUtil.isNotEmpty(orderSubStatusEntity)) {
      orderSubStatusEntity.setSubStatus(orderChannelVO.getOrderStatus());
      orderSubStatusEntity.setSubStatusDesc(orderChannelVO.getStatusDesc());
      if (ObjectUtil.isNotEmpty(orderChannelVO.getStatusTime()))
        orderSubStatusEntity.setStatusTime(LocalDateTimeUtil.of(new Date(orderChannelVO.getStatusTime().longValue()))); 
      orderSubStatusEntity.setUpdateTime(LocalDateTime.now());
      this.orderSubStatusDao.updateById(orderSubStatusEntity);
    } else {
      orderSubStatusEntity = new OrderSubStatusEntity();
      orderSubStatusEntity.setOrderId(orderEntity.getOrderId());
      orderSubStatusEntity.setOrderNo(orderEntity.getOrderNo());
      orderSubStatusEntity.setSubStatus(status);
      orderSubStatusEntity.setStatusType(statusType);
      orderSubStatusEntity.setSubStatusDesc(orderChannelVO.getStatusDesc());
      if (ObjectUtil.isNotEmpty(orderChannelVO.getStatusTime()))
        orderSubStatusEntity.setStatusTime(LocalDateTimeUtil.of(new Date(orderChannelVO.getStatusTime().longValue()))); 
      this.orderSubStatusDao.insert(orderSubStatusEntity);
    } 
    switch (statusType) {
      case "710014":
        appendOrderStatus(orderEntity, activeStatusEntity, "710013", "603001", "激活成功");
        appendOrderStatus(orderEntity, expressStatusEntity, "710012", "602003", "已签收");
        appendOrderStatus(orderEntity, acceptStatusEntity, "710011", "601001", "受理成功");
        break;
      case "710013":
        appendOrderStatus(orderEntity, expressStatusEntity, "710012", "602003", "已签收");
        appendOrderStatus(orderEntity, acceptStatusEntity, "710011", "601001", "受理成功");
        break;
      case "710012":
        appendOrderStatus(orderEntity, acceptStatusEntity, "710011", "601001", "受理成功");
        break;
    } 
  }
  
  public void appendOrderStatus(OrderEntity orderEntity, OrderSubStatusEntity orderSubStatusEntity, String type, String status, String msg) {
    if (ObjectUtil.isNotEmpty(orderSubStatusEntity)) {
      orderSubStatusEntity.setSubStatus(status);
      orderSubStatusEntity.setSubStatusDesc(msg);
      orderSubStatusEntity.setUpdateTime(LocalDateTime.now());
      this.orderSubStatusDao.updateById(orderSubStatusEntity);
    } else {
      orderSubStatusEntity = new OrderSubStatusEntity();
      orderSubStatusEntity.setOrderId(orderEntity.getOrderId());
      orderSubStatusEntity.setOrderNo(orderEntity.getOrderNo());
      orderSubStatusEntity.setSubStatus(status);
      orderSubStatusEntity.setStatusType(type);
      orderSubStatusEntity.setSubStatusDesc(msg);
      this.orderSubStatusDao.insert(orderSubStatusEntity);
    } 
  }
  
  @Transactional(rollbackFor = {Exception.class})
  public ResponseDTO<String> orderChangeOld(OrderChannelVO orderChannelVO) {
    OrderEntity orderEntity = getOrderByNo(orderChannelVO.getChannelOrderNo());
    CardOrderDetailEntity cardOrderDetailEntity = getOrderDetailByOrderId(orderEntity.getOrderId());
    orderEntity.setPartnerOrderNo(orderChannelVO.getOrderNo());
    BigDecimal rechargeAmount = ObjectUtil.isNotEmpty(orderChannelVO.getRechargeAmount()) ? new BigDecimal(orderChannelVO.getRechargeAmount()) : BigDecimal.ZERO;
    if (("604001".equals(orderChannelVO.getRechargeStatus()) || 
      SmartBigDecimalUtil.isGreaterThan(rechargeAmount, BigDecimal.ZERO)) && "610104"
      .compareTo(orderEntity.getOrderStatus()) > 0) {
      if (!"610102".equals(orderEntity.getOrderStatus())) {
        CardProductEntity cardProductEntity = this.cardProductService.getProductById(orderEntity.getCardProductId());
        BigDecimal paymentAmount = ObjectUtil.isNotEmpty(cardProductEntity.getPaymentRule()) ? cardProductEntity.getPaymentRule() : BigDecimal.ZERO;
        if (SmartBigDecimalUtil.isGreaterThan(rechargeAmount, paymentAmount)) {
          orderEntity.setPaymentStatus("610200");
          orderEntity.setOrderStatus("610103");
          orderEntity.setAllowPaymentTime(LocalDateTime.now());
          cardOrderDetailEntity.setAllowPaymentTime(LocalDateTime.now());
          String dayStr = this.configService.getConfigValue(ConfigKeyEnum.PAYMENT_SECOND_RETURN);
          int day = 0;
          try {
            day = Integer.parseInt(dayStr);
          } catch (Exception e) {
            log.error(e.getMessage(), e);
          } 
          if ("710600".equals(orderEntity.getPaymentType()) && day == 0) {
            orderEntity.setPaymentStatus("610201");
            orderEntity.setOrderStatus("610104");
            this.orderManager.updateCommissionRecord(orderEntity);
            orderEntity.setPaymentTime(LocalDateTime.now());
          } 
        } else {
          orderEntity.setOrderStatus("610105");
        } 
      } 
      orderEntity.setOrderSubStatus(orderChannelVO.getRechargeStatus());
      orderEntity.setUpdateTime(LocalDateTime.now());
      cardOrderDetailEntity.setUpdateTime(LocalDateTime.now());
      cardOrderDetailEntity.setRechargeAmount(rechargeAmount);
    } else if ("610103".compareTo(orderEntity.getOrderStatus()) > 0 && "603001"
      .equals(orderChannelVO.getActivateStatus())) {
      if (!"610102".equals(orderEntity.getOrderStatus()))
        orderEntity.setOrderStatus("610103"); 
      orderEntity.setOrderSubStatus(orderChannelVO.getActivateStatus());
      cardOrderDetailEntity.setUpdateTime(LocalDateTime.now());
      orderEntity.setUpdateTime(LocalDateTime.now());
    } else if ("604002".equals(orderChannelVO.getRechargeStatus()) && "610103"
      .compareTo(orderEntity.getOrderStatus()) > 0) {
      if (!"610102".equals(orderEntity.getOrderStatus()))
        orderEntity.setOrderStatus("610103"); 
      orderEntity.setUpdateTime(LocalDateTime.now());
      orderEntity.setOrderSubStatus(orderChannelVO.getRechargeStatus());
    } else if (("603002".equals(orderChannelVO.getActivateStatus()) || "602002"
      .equals(orderChannelVO.getExpressStatus()) || "601002"
      .equals(orderChannelVO.getAcceptanceStatus())) && "610102"
      .compareTo(orderEntity.getOrderStatus()) > 0) {
      orderEntity.setOrderStatus("610102");
      if ("603002".compareTo(orderEntity.getOrderSubStatus()) > 0) {
        orderEntity.setOrderSubStatus(orderChannelVO.getOrderStatus());
        orderEntity.setUpdateTime(LocalDateTime.now());
      } 
    } else if (("602001".equals(orderChannelVO.getExpressStatus()) || "601001"
      .equals(orderChannelVO.getAcceptanceStatus()) || "601000"
      .equals(orderChannelVO.getAcceptanceStatus()) || "603000"
      .equals(orderChannelVO.getActivateStatus()) || "602000"
      .equals(orderChannelVO.getExpressStatus())) && "610101"
      .compareTo(orderEntity.getOrderStatus()) > 0) {
      if ("610101".compareTo(orderEntity.getOrderSubStatus()) > 0) {
        orderEntity.setOrderStatus("610101");
        orderEntity.setUpdateTime(LocalDateTime.now());
      } 
      orderEntity.setOrderSubStatus(orderChannelVO.getAcceptanceStatus());
    } else if ("610102".compareTo(orderEntity.getOrderStatus()) > 0) {
      orderEntity.setOrderStatus("610100");
      orderEntity.setOrderSubStatus(orderChannelVO.getAcceptanceStatus());
    } 
    orderEntity.setOrderSubStatusName(this.dictCacheService.selectValueNameByValueCode(orderEntity.getOrderSubStatus()));
    if (ObjectUtil.isNotEmpty(orderChannelVO.getSelectPhoneNo()))
      cardOrderDetailEntity.setSelectPhoneNo(orderChannelVO.getSelectPhoneNo()); 
    if (ObjectUtil.isNotEmpty(orderChannelVO.getExpressNo())) {
      cardOrderDetailEntity.setExpressNo(orderChannelVO.getExpressNo());
      cardOrderDetailEntity.setExpressCompany(orderChannelVO.getExpressCompany());
      orderEntity.setExpressStatus(orderChannelVO.getExpressStatus());
      orderEntity.setExpressNo(orderChannelVO.getExpressNo());
      orderEntity.setExpressCompany(orderChannelVO.getExpressCompany());
    } 
    if (ObjectUtil.isNotEmpty(orderChannelVO.getOrderStatus()) && 
      orderChannelVO.getOrderStatus().compareTo(orderEntity.getOrderSubStatus()) > 0)
      orderEntity.setOrderSubStatus(orderChannelVO.getOrderStatus()); 
    orderEntity.setStatusDesc(orderChannelVO.getStatusDesc());
    this.orderDao.updateById(orderEntity);
    this.cardOrderDetailDao.updateById(cardOrderDetailEntity);
    HttpLogEntity httpLogEntity = new HttpLogEntity();
    httpLogEntity.setOrderId(orderEntity.getOrderId());
    httpLogEntity.setSubStatus(orderChannelVO.getOrderStatus());
    httpLogEntity.setSubStatusDesc(orderChannelVO.getStatusDesc());
    if (ObjectUtil.isNotEmpty(orderChannelVO.getStatusTime()));
    this.httpLogDao.insert(httpLogEntity);
    return ResponseDTO.ok();
  }
  
  @Transactional(rollbackFor = {Exception.class})
  public void paymentMonth(OrderEntity orderEntity, BigDecimal recvhargeAmount) {
    CardProductEntity cardProductEntity = this.cardProductService.getProductById(orderEntity.getCardProductId());
    BigDecimal paymentAmount = ObjectUtil.isNotEmpty(cardProductEntity.getPaymentRule()) ? cardProductEntity.getPaymentRule() : BigDecimal.ZERO;
    if (SmartBigDecimalUtil.isGreaterThan(recvhargeAmount, paymentAmount)) {
      orderEntity.setPaymentStatus("610201");
      orderEntity.setOrderStatus("610104");
      this.orderManager.updateCommissionRecord(orderEntity);
    } 
    this.orderDao.updateById(orderEntity);
  }
  
  @Transactional(rollbackFor = {Exception.class})
  public void paymentMonth(List<OrderEntity> orderList, List<CommissionRecordEntity> recordList, List<CommissionTotalEntity> totalList, List<BalanceChangeEntity> balanceList, List<CommissionRecordTraceEntity> traceList) {
    this.orderManager.paymentMonth(orderList, recordList, totalList, balanceList, traceList);
  }
  
  public ResponseDTO<String> update(OrderUpdateForm updateForm) {
    OrderEntity orderEntity = (OrderEntity)SmartBeanUtil.copy(updateForm, OrderEntity.class);
    this.orderDao.updateById(orderEntity);
    return ResponseDTO.ok();
  }
  
  public int update(OrderEntity orderEntity) {
    return this.orderDao.updateById(orderEntity);
  }
  
  public void updateOrderAndRecords(OrderEntity orderEntity, List<CommissionRecordEntity> recordEntityList) {
    this.orderManager.updateOrderAndRecords(orderEntity, recordEntityList);
  }
  
  public ResponseDTO<String> batchDelete(List<Long> idList) {
    if (CollectionUtils.isEmpty(idList))
      return ResponseDTO.ok(); 
    this.orderDao.batchUpdateDeleted(idList, true);
    return ResponseDTO.ok();
  }
  
  public ResponseDTO<String> delete(Long orderId) {
    if (null == orderId)
      return ResponseDTO.ok(); 
    this.orderDao.updateDeleted(orderId, true);
    return ResponseDTO.ok();
  }
  
  public ResponseDTO<List<OrderSubStatusVO>> getLog(Long orderId) {
    List<OrderSubStatusVO> orderSubStatusVOS = this.orderSubStatusDao.selectByOrderId(orderId);
    if (CollectionUtils.isNotEmpty(orderSubStatusVOS)) {
      String status = ((OrderSubStatusVO)orderSubStatusVOS.get(0)).getSubStatus();
      OrderSubStatusVO orderSubStatusVO = new OrderSubStatusVO();
      String nextStatus = "";
      switch (status) {
        case "603001":
          nextStatus = "604000";
          break;
        case "602001":
        case "602003":
          nextStatus = "603000";
          break;
        case "601001":
          nextStatus = "602000";
          break;
      } 
      if (ObjectUtil.isNotEmpty(nextStatus)) {
        log.info("追加下一初始状态");
        log.info(nextStatus);
        orderSubStatusVO.setSubStatus(nextStatus);
        log.info(orderSubStatusVO.getSubStatus());
        orderSubStatusVOS.add(0, orderSubStatusVO);
      } 
    } 
    return ResponseDTO.ok(orderSubStatusVOS);
  }
  
  public PageResult<OrderVO> queryPageAgent(OrderQueryAgentForm queryForm) {
    Long requestUserId = SmartRequestUtil.getRequestUserId();
    Page<?> page = SmartPageUtil.convert2PageQuery((PageParam)queryForm);
    EmployeeVO employeeVO = this.employeeDao.getEmployeeById(requestUserId);
    if ("710100".equals(employeeVO.getUserType())) {
      queryForm.setUserType(Integer.valueOf(0));
    } else if ("710101".equals(employeeVO.getUserType())) {
      queryForm.setUserType(Integer.valueOf(1));
    } 
    if ("710103".equals(employeeVO.getUserType()))
      queryForm.setUserType(Integer.valueOf(2)); 
    List<OrderVO> list = this.orderDao.queryPageAgent(page, queryForm);
    if ("710100".equals(employeeVO.getUserType()))
      list.forEach(e -> {
            Map<?, ?> map = (Map<?, ?>)JSONObject.parseObject(e.getCommissionSnapshot(), Map.class);
            List<Long> ids = (List<Long>)map.keySet().stream().map(()).collect(Collectors.toList());
            Map<Long, EmployeeVO> employees = (Map<Long, EmployeeVO>)this.employeeDao.getEmployeeByIds(ids).stream().collect(Collectors.groupingBy(EmployeeVO::getEmployeeId, Collectors.collectingAndThen(Collectors.toList(), ())));
            for (Object key : map.keySet()) {
              JSONObject jsonObject = (JSONObject)map.get(key);
              jsonObject.put("employeeName", ((EmployeeVO)employees.get(Long.valueOf(Long.parseLong(key.toString())))).getActualName());
              jsonObject.remove("deduct");
              jsonObject.remove("type");
            } 
            e.setCommissionSnapshot(null);
            e.setCommissionSnapshotBusiness(map);
          }); 
    fillOrderAmount(list, OrderVO.class, requestUserId);
    return SmartPageUtil.convert2PageResult(page, list);
  }
  
  public OrderEntity getOrderByNo(String orderNo) {
    QueryWrapper queryWrapper = new QueryWrapper();
    queryWrapper.eq("order_no", orderNo);
    return (OrderEntity)this.orderDao.selectOne((Wrapper)queryWrapper);
  }
  
  public CardOrderDetailEntity getOrderDetailByOrderId(Long orderId) {
    QueryWrapper queryWrapper = new QueryWrapper();
    queryWrapper.eq("order_id", orderId);
    return (CardOrderDetailEntity)this.cardOrderDetailDao.selectOne((Wrapper)queryWrapper);
  }
  
  public Map<String, Object> detail(Long orderId) {
    Long requestUserId = SmartRequestUtil.getRequestUserId();
    CardOrderDetailEntity cardOrderDetail = getOrderDetailByOrderId(orderId);
    OrderEntity orderEntity = (OrderEntity)this.orderDao.selectById(orderId);
    if (orderEntity == null)
      throw new BusinessException(UserErrorCode.ORDER_NOT_EXIST); 
    CardOrderDetailEntity orderDetail = this.cardOrderDetailDao.getByOrderId(orderId);
    if (orderDetail == null)
      throw new BusinessException(UserErrorCode.ORDER_NOT_EXIST); 
    CardProductEntity cardProductEntity = (CardProductEntity)this.cardProductDao.selectById(orderEntity.getCardProductId());
    CardProductInfoEntity cardProductInfo = this.cardProductInfoDao.getByCardProductId(cardProductEntity.getCardProductId());
    EmployeeEntity employeeEntity = (EmployeeEntity)this.employeeDao.selectById(orderEntity.getBelongUserId());
    Map<String, Object> result = new HashMap<>();
    fillOrderAmount(Collections.singletonList(orderEntity), OrderEntity.class, requestUserId);
    result.put("detail", SmartBeanUtil.copy(cardOrderDetail, CardOrderDetailVO.class));
    String allowRecheckTimes = this.configService.getConfigValue(ConfigKeyEnum.RECHECK_TIMES);
    String recheckDays = this.configService.getConfigValue(ConfigKeyEnum.RECHECK_DAYS);
    OrderPageVO orderPageVO = (OrderPageVO)SmartBeanUtil.copy(orderEntity, OrderPageVO.class);
    orderPageVO.setProvince(orderDetail.getProvince());
    orderPageVO.setCity(orderDetail.getCity());
    orderPageVO.setDistrict(orderDetail.getDistrict());
    orderPageVO.setProvinceCode(orderDetail.getProvinceCode());
    orderPageVO.setCityCode(orderDetail.getCityCode());
    orderPageVO.setDistrictCode(orderDetail.getDistrictCode());
    orderPageVO.setDetailAddress(orderDetail.getDetailAddress());
    orderPageVO.setRecheckDays(recheckDays);
    orderPageVO.setAllowRecheckTimes(Integer.valueOf(Integer.parseInt(allowRecheckTimes)));
    orderPageVO.setBelongUserName(employeeEntity.getRealNameStatus().booleanValue() ? employeeEntity.getActualName() : null);
    result.put("order", orderPageVO);
    result.put("product", SmartBeanUtil.copy(cardProductEntity, CardProductVO.class));
    result.put("info", SmartBeanUtil.copy(cardProductInfo, CardProductInfoVO.class));
    return result;
  }
  
  public OrderEntity getByOrderId(Long orderId) {
    return (OrderEntity)this.orderDao.selectById(orderId);
  }
  
  public List<Long> getByQualityTimeOut(int days, String paymentStatus) {
    return this.orderDao.getByQualityTimeOut(Integer.valueOf(days), paymentStatus);
  }
  
  @Transactional(rollbackFor = {Exception.class})
  public void batchUpdateQualityTimeOutOld(List<Long> orderIdList) {
    List<OrderEntity> orderList = this.orderDao.selectBatchIds(orderIdList);
    if (CollectionUtil.isNotEmpty(orderList)) {
      orderList = (List<OrderEntity>)orderList.stream().map(order -> {
            order.setPaymentStatus("610203");
            order.setQualityHandleStatus("610403");
            order.setOrderStatus("610105");
            return order;
          }).collect(Collectors.toList());
      List<CommissionRecordEntity> recordList = this.orderManager.getCommissionRecordsByOrderIds(orderIdList);
      if (CollectionUtil.isNotEmpty(recordList))
        recordList = (List<CommissionRecordEntity>)recordList.stream().map(record -> {
              record.setPaymentStatus("610203");
              record.setQualityResultType(Boolean.valueOf(false));
              return record;
            }).collect(Collectors.toList()); 
      List<CommissionRecordTraceEntity> traceList = this.orderManager.getTracesByOrderIds(orderIdList);
      if (CollectionUtil.isNotEmpty(traceList))
        traceList = (List<CommissionRecordTraceEntity>)traceList.stream().map(trace -> {
              trace.setOrderPaymentStatus("610203");
              trace.setQualityResultType(Boolean.valueOf(false));
              return trace;
            }).collect(Collectors.toList()); 
      this.orderManager.batchUpdateQualityTimeOut(orderList, recordList, traceList);
    } 
  }
  
  @Transactional(rollbackFor = {Exception.class})
  public void batchUpdateAppendQualityTimeOut(List<Long> orderIdList) {
    List<OrderEntity> orderList = this.orderDao.selectBatchIds(orderIdList);
    if (CollectionUtil.isNotEmpty(orderList)) {
      orderList = (List<OrderEntity>)orderList.stream().map(order -> {
            order.setPaymentStatus("610202");
            order.setQualityHandleStatus("610403");
            order.setOrderStatus("610106");
            return order;
          }).collect(Collectors.toList());
      List<CommissionRecordEntity> recordList = this.orderManager.getCommissionRecordsByOrderIds(orderIdList);
      if (CollectionUtil.isNotEmpty(recordList))
        recordList = (List<CommissionRecordEntity>)recordList.stream().map(record -> {
              record.setPaymentStatus("610202");
              record.setQualityResultType(Boolean.valueOf(false));
              return record;
            }).collect(Collectors.toList()); 
      List<CommissionRecordTraceEntity> traceList = this.orderManager.getTracesByOrderIds(orderIdList);
      if (CollectionUtil.isNotEmpty(traceList))
        traceList = (List<CommissionRecordTraceEntity>)traceList.stream().map(trace -> {
              trace.setOrderPaymentStatus("610202");
              trace.setQualityResultType(Boolean.valueOf(false));
              return trace;
            }).collect(Collectors.toList()); 
      this.orderManager.batchUpdateQualityTimeOut(orderList, recordList, traceList);
    } 
  }
  
  @Transactional(rollbackFor = {Exception.class})
  public void batchUpdateQualityTimeOut(List<Long> orderIdList) {
    List<OrderEntity> orderList = this.orderDao.selectBatchIds(orderIdList);
    if (CollectionUtil.isNotEmpty(orderList)) {
      orderList = (List<OrderEntity>)orderList.stream().map(order -> {
            order.setPaymentStatus("610203");
            order.setQualityHandleStatus("610403");
            order.setOrderStatus("610105");
            return order;
          }).collect(Collectors.toList());
      List<CommissionRecordEntity> recordList = this.orderManager.getCommissionRecordsByOrderIds(orderIdList);
      if (CollectionUtil.isNotEmpty(recordList))
        recordList = (List<CommissionRecordEntity>)recordList.stream().map(record -> {
              record.setPaymentStatus("610203");
              record.setQualityResultType(Boolean.valueOf(false));
              return record;
            }).collect(Collectors.toList()); 
      this.orderManager.batchUpdateQualityTimeOut(orderList, recordList, null);
    } 
  }
  
  public List<OrderEntity> getAllOrder(Long userId, Integer month) {
    return this.orderDao.getAllOrder(userId, month);
  }
  
  public List<OrderEntity> getAllOrderAudit(Long userId, LocalDateTime auditTime) {
    return this.orderDao.getAllOrderAudit(userId, auditTime);
  }
  
  public List<OrderEntity> getAllOrderUserChain(Long userId) {
    return this.orderDao.getAllOrderUserChain(userId);
  }
  
  public PageResult<OrderVO> landpageQueryPage(OrderLandpageQueryForm queryForm) {
    Long requestUserId = SmartRequestUtil.getRequestUserId();
    Page<?> page = SmartPageUtil.convert2PageQuery((PageParam)queryForm);
    List<OrderVO> orderVOS = this.orderDao.landpageQueryPageAgent(page, queryForm, requestUserId);
    fillOrderAmount(orderVOS, OrderVO.class, requestUserId);
    return SmartPageUtil.convert2PageResult(page, orderVOS);
  }
  
  public PageResult<OrderVO> agentOrder(OrderQueryAgentForm queryForm) {
    Long requestUserId = SmartRequestUtil.getRequestUserId();
    Page<?> page = SmartPageUtil.convert2PageQuery((PageParam)queryForm);
    List<OrderVO> orderVOS = this.orderDao.agentOrder(page, queryForm);
    fillOrderAmount(orderVOS, OrderVO.class, requestUserId);
    return SmartPageUtil.convert2PageResult(page, orderVOS);
  }
  
  public PageResult<OrderVO> queryMyOrder(OrderLandpageQueryForm queryForm) {
    Page<?> page = SmartPageUtil.convert2PageQuery((PageParam)queryForm);
    List<OrderVO> orderVOS = this.orderDao.landpageQueryPageAgent(page, queryForm, SmartRequestUtil.getRequestUserId());
    return SmartPageUtil.convert2PageResult(page, orderVOS);
  }
  
  public PageResult<OrderPageVO> queryPageAll(OrderQueryForm queryForm, Boolean abnormal) {
    try {
      Page<?> page = SmartPageUtil.convert2PageQuery((PageParam)queryForm);
      List<OrderPageVO> orderVOS = this.orderDao.queryPageAll(page, queryForm, abnormal);
      orderVOS.forEach(e -> {
            Map<?, ?> map = (Map<?, ?>)JSONObject.parseObject(e.getCommissionSnapshot(), Map.class);
            List<Long> ids = (List<Long>)map.keySet().stream().map(()).collect(Collectors.toList());
            Map<Long, EmployeeVO> employees = (Map<Long, EmployeeVO>)this.employeeDao.getEmployeeByIds(ids).stream().collect(Collectors.groupingBy(EmployeeVO::getEmployeeId, Collectors.collectingAndThen(Collectors.toList(), ())));
            for (Object key : map.keySet()) {
              JSONObject jsonObject = (JSONObject)map.get(key);
              EmployeeVO employeeVO = employees.get(Long.valueOf(Long.parseLong(key.toString())));
              jsonObject.put("employeeName", (employeeVO != null) ? employeeVO.getActualName() : "");
              jsonObject.remove("deduct");
              jsonObject.remove("type");
            } 
            e.setCommissionSnapshot(null);
            e.setCommissionSnapshotBusiness(map);
          });
      return SmartPageUtil.convert2PageResult(page, orderVOS);
    } catch (Exception e) {
      log.error("查询报错：", e);
      throw new BusinessException(e);
    } 
  }
  
  public void setUnRechargeOrders() {
    this.orderManager.setUnRechargeOrders();
  }
  
  public void setUnActivityOrders() {
    this.orderDao.setUnActivityOrders();
  }
  
  public PageResult<OrderVO> businessAgentOrder(OrderQueryForm queryForm) {
    Long requestUserId = SmartRequestUtil.getRequestUserId();
    Page<?> page = SmartPageUtil.convert2PageQuery((PageParam)queryForm);
    List<OrderVO> list = this.orderDao.businessAgentOrder(queryForm, requestUserId);
    list.forEach(e -> {
          Map<?, ?> map = (Map<?, ?>)JSONObject.parseObject(e.getCommissionSnapshot(), Map.class);
          List<Long> ids = (List<Long>)map.keySet().stream().map(()).collect(Collectors.toList());
          Map<Long, EmployeeVO> employees = (Map<Long, EmployeeVO>)this.employeeDao.getEmployeeByIds(ids).stream().collect(Collectors.groupingBy(EmployeeVO::getEmployeeId, Collectors.collectingAndThen(Collectors.toList(), ())));
          for (Object key : map.keySet()) {
            JSONObject jsonObject = (JSONObject)map.get(key);
            jsonObject.put("employeeName", ((EmployeeVO)employees.get(Long.valueOf(Long.parseLong(key.toString())))).getActualName());
            jsonObject.remove("deduct");
            jsonObject.remove("type");
          } 
          e.setCommissionSnapshot(null);
          e.setCommissionSnapshotBusiness(map);
        });
    return SmartPageUtil.convert2PageResult(page, list);
  }
  
  @Transactional(rollbackFor = {Exception.class})
  public ResponseDTO<String> manualOrderStatusChange(OrderChannelVO orderChannelVO) {
    OrderEntity orderEntity = getOrderByNo(orderChannelVO.getChannelOrderNo());
    CardOrderDetailEntity cardOrderDetailEntity = getOrderDetailByOrderId(orderEntity.getOrderId());
    orderEntity.setPartnerOrderNo(orderChannelVO.getOrderNo());
    String status = ObjectUtil.isNotEmpty(orderChannelVO.getOrderStatus()) ? orderChannelVO.getOrderStatus() : (ObjectUtil.isNotEmpty(orderChannelVO.getRechargeStatus()) ? orderChannelVO.getRechargeStatus() : (ObjectUtil.isNotEmpty(orderChannelVO.getActivateStatus()) ? orderChannelVO.getActivateStatus() : (ObjectUtil.isNotEmpty(orderChannelVO.getAcceptanceStatus()) ? orderChannelVO.getAcceptanceStatus() : orderChannelVO.getExpressStatus())));
    HttpLogEntity httpLogEntity = new HttpLogEntity();
    httpLogEntity.setOrderId(orderEntity.getOrderId());
    httpLogEntity.setOrderNo(orderEntity.getOrderNo());
    httpLogEntity.setSubStatus(status);
    httpLogEntity.setSubStatusDesc(orderChannelVO.getStatusDesc());
    httpLogEntity.setOrderLogType(Boolean.valueOf(true));
    httpLogEntity.setRequestParam(JSONUtil.toJsonStr(orderChannelVO));
    httpLogEntity.setResponParam(ResponseDTO.ok().toString());
    if (ObjectUtil.isNull(status)) {
      httpLogEntity.setResponParam(ResponseDTO.userErrorParam("无状态信息").toString());
      this.httpLogDao.insert(httpLogEntity);
      return ResponseDTO.userErrorParam("无状态信息");
    } 
    httpLogEntity.setResponParam(ResponseDTO.ok().toString());
    this.httpLogDao.insert(httpLogEntity);
    ChangeOrderStatusService orderStatusService = OrderStatusServiceFactory.buildImpl(status);
    String statusType = orderStatusService.getOrderStatusType();
    if ("610103".compareTo(orderEntity.getOrderStatus()) > 0 && 
      !"610102".equals(orderEntity.getOrderStatus()) && 
      !"unActivity".equals(orderEntity.getRemark())) {
      orderEntity.setOrderStatus("610101");
      if (!"603001".equals(orderEntity.getOrderSubStatus()))
        orderEntity.setOrderSubStatus(status); 
      if ("604001".equals(orderChannelVO.getRechargeStatus()) && "603001"
        .equals(orderChannelVO.getActivateStatus())) {
        CardProductEntity cardProductEntity = this.cardProductService.getProductById(orderEntity.getCardProductId());
        BigDecimal rechargeAmount = ObjectUtil.isNotEmpty(orderChannelVO.getRechargeAmount()) ? new BigDecimal(orderChannelVO.getRechargeAmount()) : BigDecimal.ZERO;
        BigDecimal paymentAmount = ObjectUtil.isNotEmpty(cardProductEntity.getPaymentRule()) ? cardProductEntity.getPaymentRule() : BigDecimal.ZERO;
        if (SmartBigDecimalUtil.isGreaterOrEqual(rechargeAmount, paymentAmount)) {
          this.orderManager.addCommissionRecord(orderEntity, rechargeAmount, paymentAmount);
          orderEntity.setPaymentStatus("610200");
          orderEntity.setOrderStatus("610103");
          orderEntity.setAllowPaymentTime(LocalDateTime.now());
          cardOrderDetailEntity.setAllowPaymentTime(LocalDateTime.now());
          orderEntity.setStatusDesc(orderChannelVO.getStatusDesc());
        } else {
          orderEntity.setOrderStatus("610102");
          orderEntity.setStatusDesc("首充不达标，不结算佣金");
        } 
      } 
      orderEntity.setUpdateTime(LocalDateTime.now());
    } 
    if (ObjectUtil.isNotEmpty(orderChannelVO.getRechargeAmount())) {
      cardOrderDetailEntity.setUpdateTime(LocalDateTime.now());
      cardOrderDetailEntity.setRechargeAmount(new BigDecimal(orderChannelVO.getRechargeAmount()));
    } 
    orderEntity.setOrderSubStatusName(this.dictCacheService.selectValueNameByValueCode(status));
    if (ObjectUtil.isNotEmpty(orderChannelVO.getSelectPhoneNo())) {
      cardOrderDetailEntity.setSelectPhoneNo(orderChannelVO.getSelectPhoneNo());
      orderEntity.setBusinessNo(orderChannelVO.getSelectPhoneNo());
    } 
    if (ObjectUtil.isNotEmpty(orderChannelVO.getExpressNo())) {
      cardOrderDetailEntity.setExpressNo(orderChannelVO.getExpressNo());
      cardOrderDetailEntity.setExpressCompany(orderChannelVO.getExpressCompany());
      orderEntity.setExpressStatus(orderChannelVO.getExpressStatus());
      orderEntity.setExpressNo(orderChannelVO.getExpressNo());
      orderEntity.setExpressCompany(orderChannelVO.getExpressCompany());
    } 
    if (ObjectUtil.isNotEmpty(orderChannelVO.getSelectPhoneNoIccid()))
      cardOrderDetailEntity.setSelectPhoneNoIccid(orderChannelVO.getSelectPhoneNoIccid()); 
    if (ObjectUtil.isNotEmpty(orderChannelVO.getCardOrderDetail()))
      cardOrderDetailEntity.setDeputySelectPhoneNoInfo(orderChannelVO.getCardOrderDetail()); 
    this.orderDao.updateById(orderEntity);
    this.cardOrderDetailDao.updateById(cardOrderDetailEntity);
    OrderSubStatusEntity orderSubStatusEntity = this.orderSubStatusDao.selectByOrderIdAndStatusType(orderEntity.getOrderId(), statusType);
    if (ObjectUtil.isNotEmpty(orderSubStatusEntity)) {
      orderSubStatusEntity.setSubStatus(status);
      orderSubStatusEntity.setSubStatusDesc(orderChannelVO.getStatusDesc());
      if (ObjectUtil.isNotEmpty(orderChannelVO.getStatusTime()))
        orderSubStatusEntity.setStatusTime(LocalDateTimeUtil.of(new Date(orderChannelVO.getStatusTime().longValue()))); 
      orderSubStatusEntity.setUpdateTime(LocalDateTime.now());
      this.orderSubStatusDao.updateById(orderSubStatusEntity);
    } else {
      orderSubStatusEntity = new OrderSubStatusEntity();
      orderSubStatusEntity.setOrderId(orderEntity.getOrderId());
      orderSubStatusEntity.setOrderNo(orderEntity.getOrderNo());
      orderSubStatusEntity.setSubStatus(status);
      orderSubStatusEntity.setStatusType(statusType);
      orderSubStatusEntity.setSubStatusDesc(orderChannelVO.getStatusDesc());
      if (ObjectUtil.isNotEmpty(orderChannelVO.getStatusTime()))
        orderSubStatusEntity.setStatusTime(LocalDateTimeUtil.of(new Date(orderChannelVO.getStatusTime().longValue()))); 
      this.orderSubStatusDao.insert(orderSubStatusEntity);
    } 
    return ResponseDTO.ok();
  }
  
  @Transactional(rollbackFor = {Exception.class})
  public ResponseDTO<String> manualOrderInfoChange(OrderChannelVO orderChannelVO) {
    OrderEntity orderEntity = getOrderByNo(orderChannelVO.getChannelOrderNo());
    orderEntity.setPartnerOrderNo(orderChannelVO.getOrderNo());
    String status = ObjectUtil.isNotEmpty(orderChannelVO.getOrderStatus()) ? orderChannelVO.getOrderStatus() : (ObjectUtil.isNotEmpty(orderChannelVO.getRechargeStatus()) ? orderChannelVO.getRechargeStatus() : (ObjectUtil.isNotEmpty(orderChannelVO.getActivateStatus()) ? orderChannelVO.getActivateStatus() : (ObjectUtil.isNotEmpty(orderChannelVO.getAcceptanceStatus()) ? orderChannelVO.getAcceptanceStatus() : orderChannelVO.getExpressStatus())));
    HttpLogEntity httpLogEntity = new HttpLogEntity();
    httpLogEntity.setOrderId(orderEntity.getOrderId());
    httpLogEntity.setOrderNo(orderEntity.getOrderNo());
    httpLogEntity.setSubStatus(status);
    httpLogEntity.setSubStatusDesc(orderChannelVO.getStatusDesc());
    httpLogEntity.setOrderLogType(Boolean.valueOf(true));
    httpLogEntity.setRequestParam(JSONUtil.toJsonStr(orderChannelVO));
    httpLogEntity.setResponParam(ResponseDTO.ok().toString());
    if (ObjectUtil.isEmpty(orderChannelVO.getCardOrderInfo())) {
      httpLogEntity.setResponParam(ResponseDTO.userErrorParam("无更新订单信息").toString());
      this.httpLogDao.insert(httpLogEntity);
      return ResponseDTO.userErrorParam("无更新订单信息");
    } 
    httpLogEntity.setResponParam(ResponseDTO.ok().toString());
    this.httpLogDao.insert(httpLogEntity);
    orderEntity.setUpdateTime(LocalDateTime.now());
    CardOrderDetailEntity cardOrderDetailEntity = getOrderDetailByOrderId(orderEntity.getOrderId());
    if (ObjectUtil.isNotEmpty(orderChannelVO.getRechargeAmount())) {
      cardOrderDetailEntity.setUpdateTime(LocalDateTime.now());
      cardOrderDetailEntity.setRechargeAmount(new BigDecimal(orderChannelVO.getRechargeAmount()));
    } 
    orderEntity.setOrderSubStatusName(this.dictCacheService.selectValueNameByValueCode(status));
    if (ObjectUtil.isNotEmpty(orderChannelVO.getSelectPhoneNo())) {
      cardOrderDetailEntity.setSelectPhoneNo(orderChannelVO.getSelectPhoneNo());
      orderEntity.setBusinessNo(orderChannelVO.getSelectPhoneNo());
    } 
    if (ObjectUtil.isNotEmpty(orderChannelVO.getExpressNo())) {
      cardOrderDetailEntity.setExpressNo(orderChannelVO.getExpressNo());
      cardOrderDetailEntity.setExpressCompany(orderChannelVO.getExpressCompany());
      orderEntity.setExpressStatus(orderChannelVO.getExpressStatus());
      orderEntity.setExpressNo(orderChannelVO.getExpressNo());
      orderEntity.setExpressCompany(orderChannelVO.getExpressCompany());
    } 
    if (ObjectUtil.isNotEmpty(orderChannelVO.getSelectPhoneNoIccid()))
      cardOrderDetailEntity.setSelectPhoneNoIccid(orderChannelVO.getSelectPhoneNoIccid()); 
    JSONObject cardOrder = JSON.parseObject(orderChannelVO.getCardOrderInfo());
    orderEntity.setCustomerAddress(cardOrder.getString("province") + cardOrder.getString("city") + cardOrder
        .getString("district") + cardOrder.getString("detailAddress"));
    orderEntity.setCustomerIdcard(cardOrder.getString("customerIdcard"));
    orderEntity.setCustomerName(cardOrder.getString("customerName"));
    orderEntity.setCustomerPhone(cardOrder.getString("customerPhone"));
    cardOrderDetailEntity.setCustomerIdcard(cardOrder.getString("customerIdcard"));
    cardOrderDetailEntity.setCustomerName(cardOrder.getString("customerName"));
    cardOrderDetailEntity.setCustomerPhone(cardOrder.getString("customerPhone"));
    cardOrderDetailEntity.setProvince(cardOrder.getString("province"));
    cardOrderDetailEntity.setProvinceCode(cardOrder.getString("provinceCode"));
    cardOrderDetailEntity.setCity(cardOrder.getString("city"));
    cardOrderDetailEntity.setCityCode(cardOrder.getString("cityCode"));
    cardOrderDetailEntity.setDistrict(cardOrder.getString("district"));
    cardOrderDetailEntity.setDistrictCode(cardOrder.getString("districtCode"));
    cardOrderDetailEntity.setDetailAddress(cardOrder.getString("detailAddress"));
    this.orderDao.updateById(orderEntity);
    this.cardOrderDetailDao.updateById(cardOrderDetailEntity);
    return ResponseDTO.ok();
  }
}
